from imdb import Cinemagoer

class Data:
    def __init__(self):
        self.ia = Cinemagoer()

    def search_person(self, name):
        person = self.ia.search_person(name.lower().strip())[0]
        return person

    def get_person(self, person_id):
        films = {}
        detail = self.ia.get_person_filmography(str(person_id))
        for val in detail.values():
            for k,v in val.items():
                if 'title' in v:
                    films[str(getattr(v, 'movieID'))] = k
        return films

    def search_movie(self, title):
        films = {}
        movies = self.ia.search_movie(title)
        for movie in movies:
            films[str(getattr(movie, 'movieID'))] = movie
        return films

    def get_movie(self, movie_id):
        data = self.ia.get_movie(str(movie_id))
        details = {}

        details['cover url'] = data.get('full-size cover url')
        details['title'] = data.get('title')
        details['genre'] = ', '.join(data.get('genre'))
        details['year'] = data.get('year')
        details['rating'] = data.get('rating')
        details['plot outline'] = data.get('plot outline')
        details['cast'] = [str(name) for key in data.keys() if key == 'cast' for name in data.get(key)]
 
        return details
